searchNodes=[{"ref":"Fields.AES.html","title":"Fields.AES","type":"module","doc":"Encrypt values with AES in Galois/Counter Mode (GCM) https://en.wikipedia.org/wiki/Galois/Counter_Mode using a random Initialisation Vector for each encryption, this makes &quot;bruteforce&quot; decryption much more difficult. See encrypt/1 and decrypt/1 for more details."},{"ref":"Fields.AES.html#decrypt/1","title":"Fields.AES.decrypt/1","type":"function","doc":"Decrypt a binary using GCM. Parameters ciphertext: a binary to decrypt, assuming that the first 16 bytes of the binary are the IV to use for decryption. key_id: the index of the AES encryption key used to encrypt the ciphertext Example iex&gt; Fields.AES.encrypt(&quot;test&quot;) |&gt; Fields.AES.decrypt() &quot;test&quot;"},{"ref":"Fields.AES.html#encrypt/1","title":"Fields.AES.encrypt/1","type":"function","doc":"Encrypt Using AES Galois/Counter Mode (GCM) https://en.wikipedia.org/wiki/Galois/Counter_Mode Uses a random IV for each call, and prepends the IV and Tag to the ciphertext. This means that encrypt/1 will never return the same ciphertext for the same value. This makes &quot;cracking&quot; (bruteforce decryption) much harder! Parameters plaintext: Accepts any data type as all values are converted to a String using to_string before encryption. key_id: the index of the AES encryption key used to encrypt the ciphertext Examples iex&gt; Fields.AES.encrypt(&quot;tea&quot;) != Fields.AES.encrypt(&quot;tea&quot;) true iex&gt; ciphertext = Fields.AES.encrypt(123) iex&gt; is_binary(ciphertext) true"},{"ref":"Fields.Address.html","title":"Fields.Address","type":"module","doc":"An Ecto Type for plaintext addresses. Useful for publicly available addressses. See Fields.AddressEncrypted for storing addresses that are Personally Identifiable Information. Example schema &quot;retailers&quot; do field :address, Fields.Address end"},{"ref":"Fields.Address.html#cast/1","title":"Fields.Address.cast/1","type":"function","doc":"Casts the given input to the custom type. This callback is called on external input and can return any type, as long as the dump/1 function is able to convert the returned value into an Ecto native type. There are two situations where this callback is called: When casting values by Ecto.Changeset When passing arguments to Ecto.Query When returning {:error, keyword()}, the returned keyword list will be preserved in the changeset errors, similar to Changeset.add_error/4. Passing a :message key, will override the default message. It is not possible to override the :type key. For {:array, CustomType} or {:map, CustomType} the returned keyword list will be erased and the default error will be shown. Callback implementation for Ecto.Type.cast/1."},{"ref":"Fields.Address.html#dump/1","title":"Fields.Address.dump/1","type":"function","doc":"Dumps the given term into an Ecto native type. This callback is called with any term that was stored in the struct and it needs to validate them and convert it to an Ecto native type. Callback implementation for Ecto.Type.dump/1."},{"ref":"Fields.Address.html#embed_as/1","title":"Fields.Address.embed_as/1","type":"function","doc":"Dictates how the type should be treated inside embeds. By default, the type is sent as itself, without calling dumping to keep the higher level representation. But it can be set to :dump to it is dumped before encoded. Callback implementation for Ecto.Type.embed_as/1."},{"ref":"Fields.Address.html#equal?/2","title":"Fields.Address.equal?/2","type":"function","doc":"Checks if two terms are semantically equal. Callback implementation for Ecto.Type.equal?/2."},{"ref":"Fields.Address.html#load/1","title":"Fields.Address.load/1","type":"function","doc":"Loads the given term into a custom type. This callback is called when loading data from the database and receives an Ecto native type. It can return any type, as long as the dump/1 function is able to convert the returned value back into an Ecto native type. Callback implementation for Ecto.Type.load/1."},{"ref":"Fields.Address.html#type/0","title":"Fields.Address.type/0","type":"function","doc":"Returns the underlying schema type for the custom type. For example, if you want to provide your own date structures, the type function should return :date. Note this function is not required to return Ecto primitive types, the type is only required to be known by the adapter. Callback implementation for Ecto.Type.type/0."},{"ref":"Fields.AddressEncrypted.html","title":"Fields.AddressEncrypted","type":"module","doc":"An Ecto Type for encrypted addresses. Example schema &quot;users&quot; do field(:address, Fields.AddressEncrypted) end"},{"ref":"Fields.AddressEncrypted.html#cast/1","title":"Fields.AddressEncrypted.cast/1","type":"function","doc":"Casts the given input to the custom type. This callback is called on external input and can return any type, as long as the dump/1 function is able to convert the returned value into an Ecto native type. There are two situations where this callback is called: When casting values by Ecto.Changeset When passing arguments to Ecto.Query When returning {:error, keyword()}, the returned keyword list will be preserved in the changeset errors, similar to Changeset.add_error/4. Passing a :message key, will override the default message. It is not possible to override the :type key. For {:array, CustomType} or {:map, CustomType} the returned keyword list will be erased and the default error will be shown. Callback implementation for Ecto.Type.cast/1."},{"ref":"Fields.AddressEncrypted.html#dump/1","title":"Fields.AddressEncrypted.dump/1","type":"function","doc":"Dumps the given term into an Ecto native type. This callback is called with any term that was stored in the struct and it needs to validate them and convert it to an Ecto native type. Callback implementation for Ecto.Type.dump/1."},{"ref":"Fields.AddressEncrypted.html#load/1","title":"Fields.AddressEncrypted.load/1","type":"function","doc":"Loads the given term into a custom type. This callback is called when loading data from the database and receives an Ecto native type. It can return any type, as long as the dump/1 function is able to convert the returned value back into an Ecto native type. Callback implementation for Ecto.Type.load/1."},{"ref":"Fields.AddressEncrypted.html#type/0","title":"Fields.AddressEncrypted.type/0","type":"function","doc":"Returns the underlying schema type for the custom type. For example, if you want to provide your own date structures, the type function should return :date. Note this function is not required to return Ecto primitive types, the type is only required to be known by the adapter. Callback implementation for Ecto.Type.type/0."},{"ref":"Fields.DescriptionPlaintextUnlimited.html","title":"Fields.DescriptionPlaintextUnlimited","type":"module","doc":"An Ecto Type for plaintext description fields with no length restrictions. Strips out all HTML tags to avoid XSS. Example schema &quot;article&quot; do field(:description, Fields.DescriptionPlaintextUnlimited) end"},{"ref":"Fields.DescriptionPlaintextUnlimited.html#cast/1","title":"Fields.DescriptionPlaintextUnlimited.cast/1","type":"function","doc":"Casts the given input to the custom type. This callback is called on external input and can return any type, as long as the dump/1 function is able to convert the returned value into an Ecto native type. There are two situations where this callback is called: When casting values by Ecto.Changeset When passing arguments to Ecto.Query When returning {:error, keyword()}, the returned keyword list will be preserved in the changeset errors, similar to Changeset.add_error/4. Passing a :message key, will override the default message. It is not possible to override the :type key. For {:array, CustomType} or {:map, CustomType} the returned keyword list will be erased and the default error will be shown. Callback implementation for Ecto.Type.cast/1."},{"ref":"Fields.DescriptionPlaintextUnlimited.html#dump/1","title":"Fields.DescriptionPlaintextUnlimited.dump/1","type":"function","doc":"Dumps the given term into an Ecto native type. This callback is called with any term that was stored in the struct and it needs to validate them and convert it to an Ecto native type. Callback implementation for Ecto.Type.dump/1."},{"ref":"Fields.DescriptionPlaintextUnlimited.html#input_type/0","title":"Fields.DescriptionPlaintextUnlimited.input_type/0","type":"function","doc":""},{"ref":"Fields.DescriptionPlaintextUnlimited.html#load/1","title":"Fields.DescriptionPlaintextUnlimited.load/1","type":"function","doc":"Loads the given term into a custom type. This callback is called when loading data from the database and receives an Ecto native type. It can return any type, as long as the dump/1 function is able to convert the returned value back into an Ecto native type. Callback implementation for Ecto.Type.load/1."},{"ref":"Fields.DescriptionPlaintextUnlimited.html#type/0","title":"Fields.DescriptionPlaintextUnlimited.type/0","type":"function","doc":"Returns the underlying schema type for the custom type. For example, if you want to provide your own date structures, the type function should return :date. Note this function is not required to return Ecto primitive types, the type is only required to be known by the adapter. Callback implementation for Ecto.Type.type/0."},{"ref":"Fields.EmailEncrypted.html","title":"Fields.EmailEncrypted","type":"module","doc":"An Ecto Type for encrypted emails. Example schema &quot;users&quot; do field(:email, Fields.EmailEncrypted) end"},{"ref":"Fields.EmailEncrypted.html#cast/1","title":"Fields.EmailEncrypted.cast/1","type":"function","doc":"Casts the given input to the custom type. This callback is called on external input and can return any type, as long as the dump/1 function is able to convert the returned value into an Ecto native type. There are two situations where this callback is called: When casting values by Ecto.Changeset When passing arguments to Ecto.Query When returning {:error, keyword()}, the returned keyword list will be preserved in the changeset errors, similar to Changeset.add_error/4. Passing a :message key, will override the default message. It is not possible to override the :type key. For {:array, CustomType} or {:map, CustomType} the returned keyword list will be erased and the default error will be shown. Callback implementation for Ecto.Type.cast/1."},{"ref":"Fields.EmailEncrypted.html#dump/1","title":"Fields.EmailEncrypted.dump/1","type":"function","doc":"Dumps the given term into an Ecto native type. This callback is called with any term that was stored in the struct and it needs to validate them and convert it to an Ecto native type. Callback implementation for Ecto.Type.dump/1."},{"ref":"Fields.EmailEncrypted.html#load/1","title":"Fields.EmailEncrypted.load/1","type":"function","doc":"Loads the given term into a custom type. This callback is called when loading data from the database and receives an Ecto native type. It can return any type, as long as the dump/1 function is able to convert the returned value back into an Ecto native type. Callback implementation for Ecto.Type.load/1."},{"ref":"Fields.EmailEncrypted.html#type/0","title":"Fields.EmailEncrypted.type/0","type":"function","doc":"Returns the underlying schema type for the custom type. For example, if you want to provide your own date structures, the type function should return :date. Note this function is not required to return Ecto primitive types, the type is only required to be known by the adapter. Callback implementation for Ecto.Type.type/0."},{"ref":"Fields.EmailHash.html","title":"Fields.EmailHash","type":"module","doc":"An Ecto Type for hashed emails. Use in conjuction with Fields.EmailEncrypted in order to be able to look up database rows by email. Hashed using sha256. See Fields.Helpers for hashing details. Example schema &quot;users&quot; do field(:email, Fields.EmailEncrypted) field(:email_hash, Fields.EmailHash) end"},{"ref":"Fields.EmailHash.html#cast/1","title":"Fields.EmailHash.cast/1","type":"function","doc":"Casts the given input to the custom type. This callback is called on external input and can return any type, as long as the dump/1 function is able to convert the returned value into an Ecto native type. There are two situations where this callback is called: When casting values by Ecto.Changeset When passing arguments to Ecto.Query When returning {:error, keyword()}, the returned keyword list will be preserved in the changeset errors, similar to Changeset.add_error/4. Passing a :message key, will override the default message. It is not possible to override the :type key. For {:array, CustomType} or {:map, CustomType} the returned keyword list will be erased and the default error will be shown. Callback implementation for Ecto.Type.cast/1."},{"ref":"Fields.EmailHash.html#dump/1","title":"Fields.EmailHash.dump/1","type":"function","doc":"Dumps the given term into an Ecto native type. This callback is called with any term that was stored in the struct and it needs to validate them and convert it to an Ecto native type. Callback implementation for Ecto.Type.dump/1."},{"ref":"Fields.EmailHash.html#load/1","title":"Fields.EmailHash.load/1","type":"function","doc":"Loads the given term into a custom type. This callback is called when loading data from the database and receives an Ecto native type. It can return any type, as long as the dump/1 function is able to convert the returned value back into an Ecto native type. Callback implementation for Ecto.Type.load/1."},{"ref":"Fields.EmailHash.html#type/0","title":"Fields.EmailHash.type/0","type":"function","doc":"Returns the underlying schema type for the custom type. For example, if you want to provide your own date structures, the type function should return :date. Note this function is not required to return Ecto primitive types, the type is only required to be known by the adapter. Callback implementation for Ecto.Type.type/0."},{"ref":"Fields.EmailPlaintext.html","title":"Fields.EmailPlaintext","type":"module","doc":"An Ecto Type for plaintext emails. Useful for publicly available email addressses such as customer support emails. See Fields.EmailEncrypted and Fields.EmailHash for storing user email addresses. Example schema &quot;retailers&quot; do field(:email, Fields.EmailPlaintext) end"},{"ref":"Fields.EmailPlaintext.html#cast/1","title":"Fields.EmailPlaintext.cast/1","type":"function","doc":"Casts the given input to the custom type. This callback is called on external input and can return any type, as long as the dump/1 function is able to convert the returned value into an Ecto native type. There are two situations where this callback is called: When casting values by Ecto.Changeset When passing arguments to Ecto.Query When returning {:error, keyword()}, the returned keyword list will be preserved in the changeset errors, similar to Changeset.add_error/4. Passing a :message key, will override the default message. It is not possible to override the :type key. For {:array, CustomType} or {:map, CustomType} the returned keyword list will be erased and the default error will be shown. Callback implementation for Ecto.Type.cast/1."},{"ref":"Fields.EmailPlaintext.html#dump/1","title":"Fields.EmailPlaintext.dump/1","type":"function","doc":"Dumps the given term into an Ecto native type. This callback is called with any term that was stored in the struct and it needs to validate them and convert it to an Ecto native type. Callback implementation for Ecto.Type.dump/1."},{"ref":"Fields.EmailPlaintext.html#load/1","title":"Fields.EmailPlaintext.load/1","type":"function","doc":"Loads the given term into a custom type. This callback is called when loading data from the database and receives an Ecto native type. It can return any type, as long as the dump/1 function is able to convert the returned value back into an Ecto native type. Callback implementation for Ecto.Type.load/1."},{"ref":"Fields.EmailPlaintext.html#type/0","title":"Fields.EmailPlaintext.type/0","type":"function","doc":"Returns the underlying schema type for the custom type. For example, if you want to provide your own date structures, the type function should return :date. Note this function is not required to return Ecto primitive types, the type is only required to be known by the adapter. Callback implementation for Ecto.Type.type/0."},{"ref":"Fields.Encrypted.html","title":"Fields.Encrypted","type":"module","doc":"An Ecto Type for encrypted fields. See Fields.AES for details on encryption/decryption. Example schema &quot;users&quot; do field(:name, Fields.Encrypted) end"},{"ref":"Fields.Encrypted.html#cast/1","title":"Fields.Encrypted.cast/1","type":"function","doc":"Casts the given input to the custom type. This callback is called on external input and can return any type, as long as the dump/1 function is able to convert the returned value into an Ecto native type. There are two situations where this callback is called: When casting values by Ecto.Changeset When passing arguments to Ecto.Query When returning {:error, keyword()}, the returned keyword list will be preserved in the changeset errors, similar to Changeset.add_error/4. Passing a :message key, will override the default message. It is not possible to override the :type key. For {:array, CustomType} or {:map, CustomType} the returned keyword list will be erased and the default error will be shown. Callback implementation for Ecto.Type.cast/1."},{"ref":"Fields.Encrypted.html#dump/1","title":"Fields.Encrypted.dump/1","type":"function","doc":"Dumps the given term into an Ecto native type. This callback is called with any term that was stored in the struct and it needs to validate them and convert it to an Ecto native type. Callback implementation for Ecto.Type.dump/1."},{"ref":"Fields.Encrypted.html#load/1","title":"Fields.Encrypted.load/1","type":"function","doc":"Loads the given term into a custom type. This callback is called when loading data from the database and receives an Ecto native type. It can return any type, as long as the dump/1 function is able to convert the returned value back into an Ecto native type. Callback implementation for Ecto.Type.load/1."},{"ref":"Fields.Encrypted.html#type/0","title":"Fields.Encrypted.type/0","type":"function","doc":"Returns the underlying schema type for the custom type. For example, if you want to provide your own date structures, the type function should return :date. Note this function is not required to return Ecto primitive types, the type is only required to be known by the adapter. Callback implementation for Ecto.Type.type/0."},{"ref":"Fields.Hash.html","title":"Fields.Hash","type":"module","doc":"An Ecto Type for hashed fields. Hashed using sha256. See Fields.Helpers for hashing details. Example schema &quot;messages&quot; do field(:digest, Fields.Hash) end"},{"ref":"Fields.Hash.html#cast/1","title":"Fields.Hash.cast/1","type":"function","doc":"Casts the given input to the custom type. This callback is called on external input and can return any type, as long as the dump/1 function is able to convert the returned value into an Ecto native type. There are two situations where this callback is called: When casting values by Ecto.Changeset When passing arguments to Ecto.Query When returning {:error, keyword()}, the returned keyword list will be preserved in the changeset errors, similar to Changeset.add_error/4. Passing a :message key, will override the default message. It is not possible to override the :type key. For {:array, CustomType} or {:map, CustomType} the returned keyword list will be erased and the default error will be shown. Callback implementation for Ecto.Type.cast/1."},{"ref":"Fields.Hash.html#dump/1","title":"Fields.Hash.dump/1","type":"function","doc":"Dumps the given term into an Ecto native type. This callback is called with any term that was stored in the struct and it needs to validate them and convert it to an Ecto native type. Callback implementation for Ecto.Type.dump/1."},{"ref":"Fields.Hash.html#load/1","title":"Fields.Hash.load/1","type":"function","doc":"Loads the given term into a custom type. This callback is called when loading data from the database and receives an Ecto native type. It can return any type, as long as the dump/1 function is able to convert the returned value back into an Ecto native type. Callback implementation for Ecto.Type.load/1."},{"ref":"Fields.Hash.html#type/0","title":"Fields.Hash.type/0","type":"function","doc":"Returns the underlying schema type for the custom type. For example, if you want to provide your own date structures, the type function should return :date. Note this function is not required to return Ecto primitive types, the type is only required to be known by the adapter. Callback implementation for Ecto.Type.type/0."},{"ref":"Fields.Helpers.html","title":"Fields.Helpers","type":"module","doc":""},{"ref":"Fields.Helpers.html#hash/2","title":"Fields.Helpers.hash/2","type":"function","doc":"Hash a string, or a value that implements the String.Chars protocol, using sha256. sha256 is fast, but not as strong as Argon2, so it is not recommended for hashing passwords."},{"ref":"Fields.HtmlBody.html","title":"Fields.HtmlBody","type":"module","doc":"An Ecto Type for bodies of html text. Strips out all HTML script tags to avoid XSS but allows other basic HTML elements to remain. Example schema &quot;article&quot; do field(:body, Fields.HtmlBody) end"},{"ref":"Fields.HtmlBody.html#cast/1","title":"Fields.HtmlBody.cast/1","type":"function","doc":"Casts the given input to the custom type. This callback is called on external input and can return any type, as long as the dump/1 function is able to convert the returned value into an Ecto native type. There are two situations where this callback is called: When casting values by Ecto.Changeset When passing arguments to Ecto.Query When returning {:error, keyword()}, the returned keyword list will be preserved in the changeset errors, similar to Changeset.add_error/4. Passing a :message key, will override the default message. It is not possible to override the :type key. For {:array, CustomType} or {:map, CustomType} the returned keyword list will be erased and the default error will be shown. Callback implementation for Ecto.Type.cast/1."},{"ref":"Fields.HtmlBody.html#dump/1","title":"Fields.HtmlBody.dump/1","type":"function","doc":"Dumps the given term into an Ecto native type. This callback is called with any term that was stored in the struct and it needs to validate them and convert it to an Ecto native type. Callback implementation for Ecto.Type.dump/1."},{"ref":"Fields.HtmlBody.html#input_type/0","title":"Fields.HtmlBody.input_type/0","type":"function","doc":""},{"ref":"Fields.HtmlBody.html#load/1","title":"Fields.HtmlBody.load/1","type":"function","doc":"Loads the given term into a custom type. This callback is called when loading data from the database and receives an Ecto native type. It can return any type, as long as the dump/1 function is able to convert the returned value back into an Ecto native type. Callback implementation for Ecto.Type.load/1."},{"ref":"Fields.HtmlBody.html#type/0","title":"Fields.HtmlBody.type/0","type":"function","doc":"Returns the underlying schema type for the custom type. For example, if you want to provide your own date structures, the type function should return :date. Note this function is not required to return Ecto primitive types, the type is only required to be known by the adapter. Callback implementation for Ecto.Type.type/0."},{"ref":"Fields.Name.html","title":"Fields.Name","type":"module","doc":"An Ecto Type for names that need to be stored securely. Example schema &quot;user&quot; do field :name, Fields.Name field :email, Fields.EmailEncrypted timestamps() end"},{"ref":"Fields.Name.html#cast/1","title":"Fields.Name.cast/1","type":"function","doc":"Casts the given input to the custom type. This callback is called on external input and can return any type, as long as the dump/1 function is able to convert the returned value into an Ecto native type. There are two situations where this callback is called: When casting values by Ecto.Changeset When passing arguments to Ecto.Query When returning {:error, keyword()}, the returned keyword list will be preserved in the changeset errors, similar to Changeset.add_error/4. Passing a :message key, will override the default message. It is not possible to override the :type key. For {:array, CustomType} or {:map, CustomType} the returned keyword list will be erased and the default error will be shown. Callback implementation for Ecto.Type.cast/1."},{"ref":"Fields.Name.html#dump/1","title":"Fields.Name.dump/1","type":"function","doc":"Dumps the given term into an Ecto native type. This callback is called with any term that was stored in the struct and it needs to validate them and convert it to an Ecto native type. Callback implementation for Ecto.Type.dump/1."},{"ref":"Fields.Name.html#embed_as/1","title":"Fields.Name.embed_as/1","type":"function","doc":"Dictates how the type should be treated inside embeds. By default, the type is sent as itself, without calling dumping to keep the higher level representation. But it can be set to :dump to it is dumped before encoded. Callback implementation for Ecto.Type.embed_as/1."},{"ref":"Fields.Name.html#equal?/2","title":"Fields.Name.equal?/2","type":"function","doc":"Checks if two terms are semantically equal. Callback implementation for Ecto.Type.equal?/2."},{"ref":"Fields.Name.html#load/1","title":"Fields.Name.load/1","type":"function","doc":"Loads the given term into a custom type. This callback is called when loading data from the database and receives an Ecto native type. It can return any type, as long as the dump/1 function is able to convert the returned value back into an Ecto native type. Callback implementation for Ecto.Type.load/1."},{"ref":"Fields.Name.html#type/0","title":"Fields.Name.type/0","type":"function","doc":"Returns the underlying schema type for the custom type. For example, if you want to provide your own date structures, the type function should return :date. Note this function is not required to return Ecto primitive types, the type is only required to be known by the adapter. Callback implementation for Ecto.Type.type/0."},{"ref":"Fields.Password.html","title":"Fields.Password","type":"module","doc":"An Ecto Type for hashed passwords. Hashed using Argon2. See Fields.Helpers for hashing details. Example schema &quot;users&quot; do field(:email, Fields.EmailEncrypted) field(:password, Fields.Password) end"},{"ref":"Fields.Password.html#cast/1","title":"Fields.Password.cast/1","type":"function","doc":"Casts the given input to the custom type. This callback is called on external input and can return any type, as long as the dump/1 function is able to convert the returned value into an Ecto native type. There are two situations where this callback is called: When casting values by Ecto.Changeset When passing arguments to Ecto.Query When returning {:error, keyword()}, the returned keyword list will be preserved in the changeset errors, similar to Changeset.add_error/4. Passing a :message key, will override the default message. It is not possible to override the :type key. For {:array, CustomType} or {:map, CustomType} the returned keyword list will be erased and the default error will be shown. Callback implementation for Ecto.Type.cast/1."},{"ref":"Fields.Password.html#dump/1","title":"Fields.Password.dump/1","type":"function","doc":"Dumps the given term into an Ecto native type. This callback is called with any term that was stored in the struct and it needs to validate them and convert it to an Ecto native type. Callback implementation for Ecto.Type.dump/1."},{"ref":"Fields.Password.html#load/1","title":"Fields.Password.load/1","type":"function","doc":"Loads the given term into a custom type. This callback is called when loading data from the database and receives an Ecto native type. It can return any type, as long as the dump/1 function is able to convert the returned value back into an Ecto native type. Callback implementation for Ecto.Type.load/1."},{"ref":"Fields.Password.html#type/0","title":"Fields.Password.type/0","type":"function","doc":"Returns the underlying schema type for the custom type. For example, if you want to provide your own date structures, the type function should return :date. Note this function is not required to return Ecto primitive types, the type is only required to be known by the adapter. Callback implementation for Ecto.Type.type/0."},{"ref":"Fields.PhoneNumber.html","title":"Fields.PhoneNumber","type":"module","doc":"An Ecto Type for plaintext phone numbers. Useful for publicly available numbers such as customer support. See Fields.PhoneNumberEncrypted for storing numbers that are Personally Identifiable Information. Example schema &quot;retailers&quot; do field(:phone_number, Fields.PhoneNumber) end"},{"ref":"Fields.PhoneNumber.html#cast/1","title":"Fields.PhoneNumber.cast/1","type":"function","doc":"Casts the given input to the custom type. This callback is called on external input and can return any type, as long as the dump/1 function is able to convert the returned value into an Ecto native type. There are two situations where this callback is called: When casting values by Ecto.Changeset When passing arguments to Ecto.Query When returning {:error, keyword()}, the returned keyword list will be preserved in the changeset errors, similar to Changeset.add_error/4. Passing a :message key, will override the default message. It is not possible to override the :type key. For {:array, CustomType} or {:map, CustomType} the returned keyword list will be erased and the default error will be shown. Callback implementation for Ecto.Type.cast/1."},{"ref":"Fields.PhoneNumber.html#dump/1","title":"Fields.PhoneNumber.dump/1","type":"function","doc":"Dumps the given term into an Ecto native type. This callback is called with any term that was stored in the struct and it needs to validate them and convert it to an Ecto native type. Callback implementation for Ecto.Type.dump/1."},{"ref":"Fields.PhoneNumber.html#load/1","title":"Fields.PhoneNumber.load/1","type":"function","doc":"Loads the given term into a custom type. This callback is called when loading data from the database and receives an Ecto native type. It can return any type, as long as the dump/1 function is able to convert the returned value back into an Ecto native type. Callback implementation for Ecto.Type.load/1."},{"ref":"Fields.PhoneNumber.html#type/0","title":"Fields.PhoneNumber.type/0","type":"function","doc":"Returns the underlying schema type for the custom type. For example, if you want to provide your own date structures, the type function should return :date. Note this function is not required to return Ecto primitive types, the type is only required to be known by the adapter. Callback implementation for Ecto.Type.type/0."},{"ref":"Fields.PhoneNumberEncrypted.html","title":"Fields.PhoneNumberEncrypted","type":"module","doc":"An Ecto Type for encrypted phone numbers. Example schema &quot;users&quot; do field(:phone_number, Fields.PhoneNumberEncrypted) end"},{"ref":"Fields.PhoneNumberEncrypted.html#cast/1","title":"Fields.PhoneNumberEncrypted.cast/1","type":"function","doc":"Casts the given input to the custom type. This callback is called on external input and can return any type, as long as the dump/1 function is able to convert the returned value into an Ecto native type. There are two situations where this callback is called: When casting values by Ecto.Changeset When passing arguments to Ecto.Query When returning {:error, keyword()}, the returned keyword list will be preserved in the changeset errors, similar to Changeset.add_error/4. Passing a :message key, will override the default message. It is not possible to override the :type key. For {:array, CustomType} or {:map, CustomType} the returned keyword list will be erased and the default error will be shown. Callback implementation for Ecto.Type.cast/1."},{"ref":"Fields.PhoneNumberEncrypted.html#dump/1","title":"Fields.PhoneNumberEncrypted.dump/1","type":"function","doc":"Dumps the given term into an Ecto native type. This callback is called with any term that was stored in the struct and it needs to validate them and convert it to an Ecto native type. Callback implementation for Ecto.Type.dump/1."},{"ref":"Fields.PhoneNumberEncrypted.html#load/1","title":"Fields.PhoneNumberEncrypted.load/1","type":"function","doc":"Loads the given term into a custom type. This callback is called when loading data from the database and receives an Ecto native type. It can return any type, as long as the dump/1 function is able to convert the returned value back into an Ecto native type. Callback implementation for Ecto.Type.load/1."},{"ref":"Fields.PhoneNumberEncrypted.html#type/0","title":"Fields.PhoneNumberEncrypted.type/0","type":"function","doc":"Returns the underlying schema type for the custom type. For example, if you want to provide your own date structures, the type function should return :date. Note this function is not required to return Ecto primitive types, the type is only required to be known by the adapter. Callback implementation for Ecto.Type.type/0."},{"ref":"Fields.Postcode.html","title":"Fields.Postcode","type":"module","doc":"An Ecto Type for plaintext postcodes. Use for publicly available postcodes. For personal data, use Fields.PostcodeEncrypted instead. Example schema &quot;retailers&quot; do field(:postcode, Fields.Postcode) end"},{"ref":"Fields.Postcode.html#cast/1","title":"Fields.Postcode.cast/1","type":"function","doc":"Casts the given input to the custom type. This callback is called on external input and can return any type, as long as the dump/1 function is able to convert the returned value into an Ecto native type. There are two situations where this callback is called: When casting values by Ecto.Changeset When passing arguments to Ecto.Query When returning {:error, keyword()}, the returned keyword list will be preserved in the changeset errors, similar to Changeset.add_error/4. Passing a :message key, will override the default message. It is not possible to override the :type key. For {:array, CustomType} or {:map, CustomType} the returned keyword list will be erased and the default error will be shown. Callback implementation for Ecto.Type.cast/1."},{"ref":"Fields.Postcode.html#dump/1","title":"Fields.Postcode.dump/1","type":"function","doc":"Dumps the given term into an Ecto native type. This callback is called with any term that was stored in the struct and it needs to validate them and convert it to an Ecto native type. Callback implementation for Ecto.Type.dump/1."},{"ref":"Fields.Postcode.html#load/1","title":"Fields.Postcode.load/1","type":"function","doc":"Loads the given term into a custom type. This callback is called when loading data from the database and receives an Ecto native type. It can return any type, as long as the dump/1 function is able to convert the returned value back into an Ecto native type. Callback implementation for Ecto.Type.load/1."},{"ref":"Fields.Postcode.html#type/0","title":"Fields.Postcode.type/0","type":"function","doc":"Returns the underlying schema type for the custom type. For example, if you want to provide your own date structures, the type function should return :date. Note this function is not required to return Ecto primitive types, the type is only required to be known by the adapter. Callback implementation for Ecto.Type.type/0."},{"ref":"Fields.PostcodeEncrypted.html","title":"Fields.PostcodeEncrypted","type":"module","doc":"An Ecto Type for encrypted postcodes. See Fields.AES for details on encryption/decryption. Example schema &quot;users&quot; do field(:email, Fields.EmailEncrypted) field(:postcode, Fields.PostcodeEncrypted) end"},{"ref":"Fields.PostcodeEncrypted.html#cast/1","title":"Fields.PostcodeEncrypted.cast/1","type":"function","doc":"Casts the given input to the custom type. This callback is called on external input and can return any type, as long as the dump/1 function is able to convert the returned value into an Ecto native type. There are two situations where this callback is called: When casting values by Ecto.Changeset When passing arguments to Ecto.Query When returning {:error, keyword()}, the returned keyword list will be preserved in the changeset errors, similar to Changeset.add_error/4. Passing a :message key, will override the default message. It is not possible to override the :type key. For {:array, CustomType} or {:map, CustomType} the returned keyword list will be erased and the default error will be shown. Callback implementation for Ecto.Type.cast/1."},{"ref":"Fields.PostcodeEncrypted.html#dump/1","title":"Fields.PostcodeEncrypted.dump/1","type":"function","doc":"Dumps the given term into an Ecto native type. This callback is called with any term that was stored in the struct and it needs to validate them and convert it to an Ecto native type. Callback implementation for Ecto.Type.dump/1."},{"ref":"Fields.PostcodeEncrypted.html#load/1","title":"Fields.PostcodeEncrypted.load/1","type":"function","doc":"Loads the given term into a custom type. This callback is called when loading data from the database and receives an Ecto native type. It can return any type, as long as the dump/1 function is able to convert the returned value back into an Ecto native type. Callback implementation for Ecto.Type.load/1."},{"ref":"Fields.PostcodeEncrypted.html#type/0","title":"Fields.PostcodeEncrypted.type/0","type":"function","doc":"Returns the underlying schema type for the custom type. For example, if you want to provide your own date structures, the type function should return :date. Note this function is not required to return Ecto primitive types, the type is only required to be known by the adapter. Callback implementation for Ecto.Type.type/0."},{"ref":"Fields.Url.html","title":"Fields.Url","type":"module","doc":"An Ecto Type for urls. Use Fields.UrlEncrypted for encrypted urls. Example schema &quot;retailers&quot; do field :url, Fields.Url end"},{"ref":"Fields.Url.html#cast/1","title":"Fields.Url.cast/1","type":"function","doc":"Casts the given input to the custom type. This callback is called on external input and can return any type, as long as the dump/1 function is able to convert the returned value into an Ecto native type. There are two situations where this callback is called: When casting values by Ecto.Changeset When passing arguments to Ecto.Query When returning {:error, keyword()}, the returned keyword list will be preserved in the changeset errors, similar to Changeset.add_error/4. Passing a :message key, will override the default message. It is not possible to override the :type key. For {:array, CustomType} or {:map, CustomType} the returned keyword list will be erased and the default error will be shown. Callback implementation for Ecto.Type.cast/1."},{"ref":"Fields.Url.html#dump/1","title":"Fields.Url.dump/1","type":"function","doc":"Dumps the given term into an Ecto native type. This callback is called with any term that was stored in the struct and it needs to validate them and convert it to an Ecto native type. Callback implementation for Ecto.Type.dump/1."},{"ref":"Fields.Url.html#embed_as/1","title":"Fields.Url.embed_as/1","type":"function","doc":"Dictates how the type should be treated inside embeds. By default, the type is sent as itself, without calling dumping to keep the higher level representation. But it can be set to :dump to it is dumped before encoded. Callback implementation for Ecto.Type.embed_as/1."},{"ref":"Fields.Url.html#equal?/2","title":"Fields.Url.equal?/2","type":"function","doc":"Checks if two terms are semantically equal. Callback implementation for Ecto.Type.equal?/2."},{"ref":"Fields.Url.html#load/1","title":"Fields.Url.load/1","type":"function","doc":"Loads the given term into a custom type. This callback is called when loading data from the database and receives an Ecto native type. It can return any type, as long as the dump/1 function is able to convert the returned value back into an Ecto native type. Callback implementation for Ecto.Type.load/1."},{"ref":"Fields.Url.html#type/0","title":"Fields.Url.type/0","type":"function","doc":"Returns the underlying schema type for the custom type. For example, if you want to provide your own date structures, the type function should return :date. Note this function is not required to return Ecto primitive types, the type is only required to be known by the adapter. Callback implementation for Ecto.Type.type/0."},{"ref":"Fields.UrlEncrypted.html","title":"Fields.UrlEncrypted","type":"module","doc":"An Ecto Type for urls that need to be stored securely. Example ``` schema &quot;bookmarks&quot; do field :url, Fields.UrlEncrypted timestamps() end ```"},{"ref":"Fields.UrlEncrypted.html#cast/1","title":"Fields.UrlEncrypted.cast/1","type":"function","doc":"Casts the given input to the custom type. This callback is called on external input and can return any type, as long as the dump/1 function is able to convert the returned value into an Ecto native type. There are two situations where this callback is called: When casting values by Ecto.Changeset When passing arguments to Ecto.Query When returning {:error, keyword()}, the returned keyword list will be preserved in the changeset errors, similar to Changeset.add_error/4. Passing a :message key, will override the default message. It is not possible to override the :type key. For {:array, CustomType} or {:map, CustomType} the returned keyword list will be erased and the default error will be shown. Callback implementation for Ecto.Type.cast/1."},{"ref":"Fields.UrlEncrypted.html#dump/1","title":"Fields.UrlEncrypted.dump/1","type":"function","doc":"Dumps the given term into an Ecto native type. This callback is called with any term that was stored in the struct and it needs to validate them and convert it to an Ecto native type. Callback implementation for Ecto.Type.dump/1."},{"ref":"Fields.UrlEncrypted.html#embed_as/1","title":"Fields.UrlEncrypted.embed_as/1","type":"function","doc":"Dictates how the type should be treated inside embeds. By default, the type is sent as itself, without calling dumping to keep the higher level representation. But it can be set to :dump to it is dumped before encoded. Callback implementation for Ecto.Type.embed_as/1."},{"ref":"Fields.UrlEncrypted.html#equal?/2","title":"Fields.UrlEncrypted.equal?/2","type":"function","doc":"Checks if two terms are semantically equal. Callback implementation for Ecto.Type.equal?/2."},{"ref":"Fields.UrlEncrypted.html#load/1","title":"Fields.UrlEncrypted.load/1","type":"function","doc":"Loads the given term into a custom type. This callback is called when loading data from the database and receives an Ecto native type. It can return any type, as long as the dump/1 function is able to convert the returned value back into an Ecto native type. Callback implementation for Ecto.Type.load/1."},{"ref":"Fields.UrlEncrypted.html#type/0","title":"Fields.UrlEncrypted.type/0","type":"function","doc":"Returns the underlying schema type for the custom type. For example, if you want to provide your own date structures, the type function should return :date. Note this function is not required to return Ecto primitive types, the type is only required to be known by the adapter. Callback implementation for Ecto.Type.type/0."},{"ref":"Fields.Validate.html","title":"Fields.Validate","type":"module","doc":"Helper functions to validate the data in certain fields"},{"ref":"Fields.Validate.html#address/1","title":"Fields.Validate.address/1","type":"function","doc":"Validate an address. Currently just validates that some input has been given."},{"ref":"Fields.Validate.html#email/1","title":"Fields.Validate.email/1","type":"function","doc":"Validate the format of an email address using a regex. Uses a slightly modified version of the w3c HTML5 spec email regex (https://www.w3.org/TR/html5/forms.html#valid-e-mail-address), with additions to account for not allowing emails to start or end with &#39;.&#39;, and a check that there are no consecutive &#39;.&#39;s."},{"ref":"Fields.Validate.html#name/1","title":"Fields.Validate.name/1","type":"function","doc":"Validate the length of a name is less than 35 characters"},{"ref":"Fields.Validate.html#phone_number/1","title":"Fields.Validate.phone_number/1","type":"function","doc":"Validates the format of a UK phone number."},{"ref":"Fields.Validate.html#postcode/1","title":"Fields.Validate.postcode/1","type":"function","doc":"Validate the format of an postcode using a regex. All existing postcodes in the UK should pass this validation; some non-existent ones may too if they follow the standard UK postcode format."},{"ref":"Fields.Validate.html#url/1","title":"Fields.Validate.url/1","type":"function","doc":"Validate the format of a url using a regex. See https://git.io/fpdad for details on how the regex for validation was chosen"}]